#include "gp2x.h"

#ifndef __DEFINE
#define __DEFINE

#define WP 65536
#define WWP (WP*2)

#define true 1
#define false 0


#define WINDOW_TITLE "WispLisp Array of List"
//ݒt@C̓e
#define CONFIGFILE_NAME "debug.txt"

#define DISPLY_WIDTH (640)
#define DISPLY_HEIGHT (360)
#define DISPLY_WIDTH_WP (DISPLY_WIDTH*WP)
#define DISPLY_HEIGHT_WP (DISPLY_HEIGHT*WP)

#define BMPBUFF_MAX (128)

#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_Y               (14)
#define GP2X_BUTTON_X               (15)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)
#define GP2X_BUTTON_EXIT            (19)
#define GP2X_BUTTON_MAX             (20)


#define VOL_MAX (128)

#define FUNC_MAX_DIR ( 1024 )
#define FUNC_HARF_DIR ( FUNC_MAX_DIR / 2 )
#define MAX_DIR ( FUNC_MAX_DIR )

enum
{
	GM_SPR_NONE,
	GM_SPR_V,
	GM_SPR_H,
	GM_SPR_HV,
};
enum
{
	EN_MINI_BLEND,
	EN_MINI_ADD,
	EN_MINI_ZYOU,
};
enum
{
	EN_DEBUGFUNC_NONE = 0,
	EN_DEBUGFUNC_PAUSE,
	EN_DEBUGFUNC_SLOW,
	EN_DEBUGFUNC_FAST1,
};

enum 
{
	FID_TOP = 1,
	FID_BOOT01_0 = FID_TOP,
	FID_BOOT01_1,
	FID_WORK01,
};
enum  
{
	EN_SN_EXIT = 0,
	EN_SN_TITLE,
	EN_SN_ACT,
	EN_SN_OPTION,
	EN_SN_ENDING,
	EN_SN_LOGO,
	EN_SN_STAGESELECT,
	EN_SN_DEMO,
	EN_SN_CREDITS,
} DISP_SCENE;

enum {
	EN_BGM_GAME01 = 0,
	EN_BGM_GAME02,
	EN_BGM_GAME03,
	EN_BGM_GAME04,
	EN_BGM_GAME05,
	EN_BGM_GAME06,
	EN_BGM_GAME07,

	EN_BGM_END   ,
};
enum {
	EN_SE_ATTACK = 0,
	EN_SE_DAMEGE,
	EN_SE_BOM1,
	EN_SE_BOM2,
	EN_SE_BOM3,
	EN_SE_BOSS_DEAD,
	EN_SE_DEFENCE,
	EN_SE_HIT,
	EN_SE_SELECT,
	EN_SE_OK,
	EN_SE_CANSEL,

	EN_SE_END   ,
};

enum {
	EN_PLAYERNUM_01 = 0,
	EN_PLAYERNUM_02,
	EN_PLAYERNUM_03,
	EN_PLAYERNUM_04,
};

enum {
	EN_INPUT_UP = 0,
	EN_INPUT_DOWN,
	EN_INPUT_LEFT,
	EN_INPUT_RIGHT,
	EN_INPUT_1,
	EN_INPUT_2,
	EN_INPUT_3,
	EN_INPUT_4,
	EN_INPUT_5,
	EN_INPUT_6,
	EN_INPUT_START,
	EN_INPUT_SELECT,
};

//Z[uf[^萔
enum {
	EN_SAVEDATA_START = 0,

	EN_SAVEDATA_SUM,
	EN_SAVEDATA_VER,
	
	EN_SAVEDATA_1P_UP,
	EN_SAVEDATA_1P_DOWN,
	EN_SAVEDATA_1P_LEFT,
	EN_SAVEDATA_1P_RIGHT,
	EN_SAVEDATA_1P_1,
	EN_SAVEDATA_1P_2,
	EN_SAVEDATA_1P_3,
	EN_SAVEDATA_1P_4,
	EN_SAVEDATA_1P_5,
	EN_SAVEDATA_1P_6,
	EN_SAVEDATA_1P_START,
	EN_SAVEDATA_1P_SELECT,

	EN_SAVEDATA_2P_UP,
	EN_SAVEDATA_2P_DOWN,
	EN_SAVEDATA_2P_LEFT,
	EN_SAVEDATA_2P_RIGHT,
	EN_SAVEDATA_2P_1,
	EN_SAVEDATA_2P_2,
	EN_SAVEDATA_2P_3,
	EN_SAVEDATA_2P_4,
	EN_SAVEDATA_2P_5,
	EN_SAVEDATA_2P_6,
	EN_SAVEDATA_2P_START,
	EN_SAVEDATA_2P_SELECT,

	EN_SAVEDATA_3P_UP,
	EN_SAVEDATA_3P_DOWN,
	EN_SAVEDATA_3P_LEFT,
	EN_SAVEDATA_3P_RIGHT,
	EN_SAVEDATA_3P_1,
	EN_SAVEDATA_3P_2,
	EN_SAVEDATA_3P_3,
	EN_SAVEDATA_3P_4,
	EN_SAVEDATA_3P_5,
	EN_SAVEDATA_3P_6,
	EN_SAVEDATA_3P_START,
	EN_SAVEDATA_3P_SELECT,

	EN_SAVEDATA_4P_UP,
	EN_SAVEDATA_4P_DOWN,
	EN_SAVEDATA_4P_LEFT,
	EN_SAVEDATA_4P_RIGHT,
	EN_SAVEDATA_4P_1,
	EN_SAVEDATA_4P_2,
	EN_SAVEDATA_4P_3,
	EN_SAVEDATA_4P_4,
	EN_SAVEDATA_4P_5,
	EN_SAVEDATA_4P_6,
	EN_SAVEDATA_4P_START,
	EN_SAVEDATA_4P_SELECT,

	EN_SAVEDATA_DISPZOOM,

	EN_SAVEDATA_MASTERVOLUME,
	EN_SAVEDATA_BGVOLUME,
	EN_SAVEDATA_SEVOLUME,
	EN_SAVEDATA_VOVOLUME,
	
	EN_SAVEDATA_PLAYTIME_F,
	EN_SAVEDATA_PLAYTIME_S,
	EN_SAVEDATA_PLAYTIME_M,
	EN_SAVEDATA_PLAYTIME_H,
	EN_SAVEDATA_CLEARTIME_F,
	EN_SAVEDATA_CLEARTIME_S,
	EN_SAVEDATA_CLEARTIME_M,
	EN_SAVEDATA_CLEARTIME_H,

	EN_SAVEDATA_SELECTLEVEL,
	
	EN_SAVEDATA_SCORE = 200,
	EN_SAVEDATA_SCORE_EASY,
	EN_SAVEDATA_SCORE_NOMAL,
	EN_SAVEDATA_SCORE_HARD,
	EN_SAVEDATA_SCORE_ENDRESS,
	EN_SAVEDATA_BULLET,
	EN_SAVEDATA_OUT_BULLET,
	EN_SAVEDATA_SHOT,
	EN_SAVEDATA_OUT_SHOT,
	EN_SAVEDATA_ENEMY,
	EN_SAVEDATA_OUT_ENEMY,
	EN_SAVEDATA_BOSS,
	EN_SAVEDATA_MISS,
	EN_SAVEDATA_MANDARA,
	EN_SAVEDATA_CLEAR,
	EN_SAVEDATA_GAMEOVER,

	EN_SAVEDATA_END   ,
};

//Q[Ǝ̒萔
enum {
	LEVEL_EASY,
	LEVEL_NOMAL,
	LEVEL_HARD,
	LEVEL_ENDRESS,
};


#endif

